(*----------------------------------------------------------------------------*)
(* Joachim Pimiskern, 2004. Freeware                                          *)
(*----------------------------------------------------------------------------*)
unit unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Memo1: TMemo;
    procedure Button1Click(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation
uses
  jpqueue;

{$R *.DFM}

procedure TForm1.Button1Click(Sender: TObject);
var q: TJpQueue;
    i: integer;
    p: pointer;
    status: boolean;
begin
  q := TJpQueue.Create;
  try
    //--- Insert ---
    for i := 0 to 5 do
    begin
      Memo1.Lines.Add('adding ' + IntToStr(i));
      q.Add(pointer(i));
    end;

    Memo1.Lines.Add('');
    //--- Read out ---
    status := q.Get(p);
    while (status = true) do
    begin
      Memo1.Lines.Add('reading ' + IntToStr(Integer(p)));
      status := q.Get(p);
    end;
  finally
    q.Free;
  end;
end;

end.
